[LeetCode] 975. Odd Even Jump 奇偶跳躍



You are given an integer array A. From some starting index, you can make a series of jumps. The (1st, 3rd, 5th, ...) jumps in the series are called odd-numbered jumps, and the (2nd, 4th, 6th, ...) jumps in the series are called even-numbered jumps. Note that the jumps are numbered, not the indices.

You may jump forward from index i to index j (with i < j) in the following way:

  • During odd-numbered jumps (i.e., jumps 1, 3, 5, ...), you jump to the index j such that A[i] <= A[j] and A[j] is the smallest possible value. If there are multiple such indices j, you can only jump to the smallest such index j.
  • During even-numbered jumps (i.e., jumps 2, 4, 6, ...), you jump to the index j such that A[i] >= A[j] and A[j] is the largest possible value. If there are multiple such indices j, you can only jump to the smallest such index j.
  • It may be the case that for some index i, there are no legal jumps.

A starting index is good if, starting from that index, you can reach the end of the array (index A.length - 1) by jumping some number of times (possibly 0 or more than once).

Return the number of good starting indices.

Example 1:

Input: A = [10,13,12,14,15]
Output: 2
Explanation:
From starting index i = 0, we can make our 1st jump to i = 2 (since A[2] is the smallest among A[1], A[2], A[3],
A[4] that is greater or equal to A[0]), then we cannot jump any more.
From starting index i = 1 and i = 2, we can make our 1st jump to i = 3, then we cannot jump any more.
From starting index i = 3, we can make our 1st jump to i = 4, so we have reached the end.
From starting index i = 4, we have reached the end already.
In total, there are 2 different starting indices i = 3 and i = 4, where we can reach the end with some number of
jumps.

Example 2:

Input: A = [2,3,1,1,4]
Output: 3
Explanation:
From starting index i = 0, we make jumps to i = 1, i = 2, i = 3:

During our 1st jump (odd-numbered), we first jump to i = 1 because A[1] is the smallest value in [A[1], A[2],
A[3], A[4]] that is greater than or equal to A[0].

During our 2nd jump (even-numbered), we jump from i = 1 to i = 2 because A[2] is the largest value in [A[2], A[3],
A[4]] that is less than or equal to A[1]. A[3] is also the largest value, but 2 is a smaller index, so we can
only jump to i = 2 and not i = 3

During our 3rd jump (odd-numbered), we jump from i = 2 to i = 3 because A[3] is the smallest value in [A[3], A[4]]
that is greater than or equal to A[2].

We can't jump from i = 3 to i = 4, so the starting index i = 0 is not good.

In a similar manner, we can deduce that:
From starting index i = 1, we jump to i = 4, so we reach the end.
From starting index i = 2, we jump to i = 3, and then we can't jump anymore.
From starting index i = 3, we jump to i = 4, so we reach the end.
From starting index i = 4, we are already at the end.
In total, there are 3 different starting indices i = 1, i = 3, and i = 4, where we can reach the end with some
number of jumps.

Example 3:

Input: A = [5,1,3,4,2]
Output: 3
Explanation:
We can reach the end from starting indices 1, 2, and 4.

Constraints:

  • 1 <= A.length <= 2 * 104
  • 0 <= A[i] < 105

這道題給了一個數組,可以在任意的位置進行跳躍,分為奇數跳躍和偶數跳躍。第一次跳躍就是奇數跳躍,第二次就是偶數,第三次又是奇數,以此類推。奇數跳躍時到達的位置上的數字必須要大於等於起跳位置的數字,若有多個位置的數字都大於等於起跳位置,選其中最小的,若數字相同,選坐標最小的。而偶數跳躍到達的位置上的數字必須要小於等於起跳位置的數字,若有多個位置的數字都小於等於起跳位置,選其中最大的,若數字相同,選坐標最小的。現在定義了一種好起點,需要能按照上面的跳躍方式到達數組最后一個位置,問有多少個這樣的好起點。說實話,這道題的題目博主是看了好久才搞懂,看到論壇上也有人吐槽題意晦澀難懂的。不過點贊數遠超踩的個數,看來還是一道不錯的題目。由於起點是任意的,那么若起點就是在最后一個位置,則就不用跳了,所以結果 res 可以初始化為1。然后就可以往前推,對於前一個數字和當前數字的關系,實際上就是大於等於,或者小於等於,可以分別對應兩種跳法,這樣其實每個位置上就有兩種狀態,一種是能否跳到大於等於的位置,用 higher 表示,一種是能否跳到小於等於的位置,用 lower 表示。這樣就可以用兩個數組 higher 和 lower 表示,其中 higher[i] 表示起點為i位置,首先跳到大於等於的位置(奇數跳躍),看是否能跳到末尾位置,這個就是題目所要求的。lower[i] 表示起點為i位置,首先跳到小於等於的位置(偶數跳躍),看是否能跳到末尾位置。則最末尾的位置 higher[n-1] 和 lower[n-1] 都要初始化為 true。在往前推的時候,需要在后方的數字中找出第一個不小於當前數字的數,和第一個不大於當前數字的數,為了快速查找,可以使用 TreeMap 來建立數字和其下標之間的映射,然后就可以用 lower_bound 和 upper_bound 來快速的查找了。這里 lower_bound 是查找第一個不小於目標值的數,正好就是要求的,只要該數字存在,則可以用該數字的 lower 值來更新當前數字的 higher 值,因為奇數跳躍和偶數跳躍是要交替進行的。這里的 upper_bound 是查找第一個大於目標的數,其往前退一位就是第一個不大於目標的數,但是在退之前,要先確定這不是第一個數字,否則沒法往前退。用查找到的數字的 higher 值來更新當前數字的 lower 值。每次若 higher 值為 true,則結果 res 自增1,參見代碼如下:


class Solution {
public:
    int oddEvenJumps(vector<int>& A) {
        int res = 1, n = A.size();
        vector<bool> higher(n), lower(n);
        higher[n - 1] = lower[n - 1] = true;
        map<int, int> num2idx;
        num2idx[A[n - 1]] = n - 1;
        for (int i = n - 2; i >= 0; --i) {
            auto hi = num2idx.lower_bound(A[i]), lo = num2idx.upper_bound(A[i]);
            if (hi != num2idx.end()) higher[i] = lower[hi->second];
            if (lo != num2idx.begin()) lower[i] = higher[(--lo)->second];
            if (higher[i]) ++res;
            num2idx[A[i]] = i;
        }
        return res;
    }
};

Github 同步地址:

https://github.com/grandyang/leetcode/issues/975


參考資料:

https://leetcode.com/problems/odd-even-jump/

https://leetcode.com/problems/odd-even-jump/discuss/217974/Java-solution-DP-%2B-TreeMap

https://leetcode.com/problems/odd-even-jump/discuss/217981/JavaC%2B%2BPython-DP-using-Map-or-Stack


LeetCode All in One 題目講解匯總(持續更新中...)


免責聲明!

本站轉載的文章為個人學習借鑒使用,本站對版權不負任何法律責任。如果侵犯了您的隱私權益,請聯系本站郵箱yoyou2525@163.com刪除。



 
粵ICP備18138465號   © 2018-2025 CODEPRJ.COM